; OPT_Res	0	   ; RichMasm assumes this code needs no resources - delete if rsrc.rc is needed
.nolist
include	\masm32\include\masm32rt.inc
include	\masm32\include\Float2Asc.inc

.code

MyReal10	REAL10	1.2345678e9
MyPI10	REAL10	3.1415926535897932384626
MyReal4	REAL4	123.456	; ->@decoration in macro call
MyInt32	dd	123456
Sales2005	REAL4	290.0
Sales2006	REAL8	300.0
Sales2007	REAL8	309.6
AppName	db "Test the float$ macro:", 0

start:
	f2sPrec = 16		; define default digits of precision (1-16)

COMMENT  ------------------------------------------      Syntax examples:    ---------------------------------

	Basic:
	print float$(MyReal10)
	print float$(@MyReal4)
	print float$(MyInt32)
	mov al, 123
	print float$(al)

	Simple:
	print float$("The number %f is very high", MyReal10)

	Four digits precision (n=1-15, use uppercase A-F for 10-15 digits):
	print float$("The number %4f is very high", MyReal10)

	Simple calculations: You can mix up to 5 registers (1-4 bytes), integers, immediate numbers, local and global variables:
	mov ecx, 3000	; Caution: edx cannot be used here, eax not after an immediate integer
	MsgBox 0, float$("Divide ecx by 10, add Sales2005,\nadd 10, multiply with 111.111;\nresult=%f", ecx/10+@Sales2005+10*111.1111), "Test:", MB_OK

	NOTE: Sales2005 is a REAL4; to distinguish it from a 4-byte integer, the @ decoration is needed when calling the macro
	*** use %f (or %Af, 10 digits precision) as placeholder for the number; use \n for newline, \t for tab ***
------------------------------------------------------------------------------------------------------------------------------------- 

	MsgBox 0, float$("PI = %If", MyPI10), "A REAL10 float variable:", MB_OKCANCEL

	.if eax==IDOK
		MsgBox 0, float$('Marketing report:\n\nSales were up\n%2f% in 2007', Sales2007/Sales2006-1*100), addr AppName, MB_OKCANCEL
		.if eax==IDOK
			mov eax, 12345678
			MsgBox 0, float$("\
			Divide\tMyReal10  \t(=1.2345678e9)\nby\t12345678  \t(=1.2e7, in eax)\
			\nadd\t11.1111    \t(immediate real)\
			\nResult=\t%7f   \tok?\
			\n\nThis message shown with one line of code!",\
			MyReal10/eax+011.1111), addr AppName, MB_OK
		.endif
	.endif

	exit

end start
OPT_Linker	polink
OPT_Tmp2Asm	1
OPT_SUSY	WINDOWS
